<?php
/**
 * The Portfolio template to display the content
 *
 * Used for index/archive/search.
 *
 * @package WordPress
 * @subpackage CREDITCARD
 * @since CREDITCARD 1.0
 */

$creditcard_blog_style = explode('_', creditcard_get_theme_option('blog_style'));
$creditcard_columns = empty($creditcard_blog_style[1]) ? 2 : max(2, $creditcard_blog_style[1]);
$creditcard_post_format = get_post_format();
$creditcard_post_format = empty($creditcard_post_format) ? 'standard' : str_replace('post-format-', '', $creditcard_post_format);
$creditcard_animation = creditcard_get_theme_option('blog_animation');

?><article id="post-<?php the_ID(); ?>" 
	<?php post_class( 'post_item post_layout_portfolio post_layout_portfolio_'.esc_attr($creditcard_columns).' post_format_'.esc_attr($creditcard_post_format).(is_sticky() && !is_paged() ? ' sticky' : '') ); ?>
	<?php echo (!creditcard_is_off($creditcard_animation) ? ' data-animation="'.esc_attr(creditcard_get_animation_classes($creditcard_animation)).'"' : ''); ?>>
	<?php

	// Sticky label
	if ( is_sticky() && !is_paged() ) {
		?><span class="post_label label_sticky"></span><?php
	}

	$creditcard_image_hover = creditcard_get_theme_option('image_hover');
	// Featured image
	creditcard_show_post_featured(array(
		'thumb_size' => creditcard_get_thumb_size(strpos(creditcard_get_theme_option('body_style'), 'full')!==false || $creditcard_columns < 3 ? 'masonry-big' : 'masonry'),
		'show_no_image' => true,
		'class' => $creditcard_image_hover == 'dots' ? 'hover_with_info' : '',
		'post_info' => $creditcard_image_hover == 'dots' ? '<div class="post_info">'.esc_html(get_the_title()).'</div>' : ''
	));
	?>
</article>