<?php
/**
 * The Sticky template to display the sticky posts
 *
 * Used for index/archive
 *
 * @package WordPress
 * @subpackage CREDITCARD
 * @since CREDITCARD 1.0
 */

$creditcard_columns = max(1, min(3, count(get_option( 'sticky_posts' ))));
$creditcard_post_format = get_post_format();
$creditcard_post_format = empty($creditcard_post_format) ? 'standard' : str_replace('post-format-', '', $creditcard_post_format);
$creditcard_animation = creditcard_get_theme_option('blog_animation');

?><div class="column-1_<?php echo esc_attr($creditcard_columns); ?>"><article id="post-<?php the_ID(); ?>" 
	<?php post_class( 'post_item post_layout_sticky post_format_'.esc_attr($creditcard_post_format) ); ?>
	<?php echo (!creditcard_is_off($creditcard_animation) ? ' data-animation="'.esc_attr(creditcard_get_animation_classes($creditcard_animation)).'"' : ''); ?>
	>

	<?php
	if ( is_sticky() && is_home() && !is_paged() ) {
		?><span class="post_label label_sticky"></span><?php
	}

	// Featured image
	creditcard_show_post_featured(array(
		'thumb_size' => creditcard_get_thumb_size($creditcard_columns==1 ? 'big' : ($creditcard_columns==2 ? 'med' : 'avatar'))
	));

	if ( !in_array($creditcard_post_format, array('link', 'aside', 'status', 'quote')) ) {
		?>
		<div class="post_header entry-header">
			<?php
			// Post title
			the_title( sprintf( '<h6 class="post_title entry-title"><a href="%s" rel="bookmark">', esc_url( get_permalink() ) ), '</a></h6>' );
			// Post meta
			creditcard_show_post_meta(apply_filters('creditcard_filter_post_meta_args', array(), 'sticky', $creditcard_columns));
			?>
		</div><!-- .entry-header -->
		<?php
	}
	?>
</article></div>