<?php
/* Contact Form 7 support functions
------------------------------------------------------------------------------- */

// Theme init priorities:
// 9 - register other filters (for installer, etc.)
if (!function_exists('creditcard_cf7_theme_setup9')) {
	add_action( 'after_setup_theme', 'creditcard_cf7_theme_setup9', 9 );
	function creditcard_cf7_theme_setup9() {
		
		if (creditcard_exists_cf7()) {
			add_action( 'wp_enqueue_scripts', 								'creditcard_cf7_frontend_scripts', 1100 );
			add_filter( 'creditcard_filter_merge_styles',						'creditcard_cf7_merge_styles' );
			add_filter( 'creditcard_filter_merge_scripts', 'creditcard_cf7_merge_scripts' );
		}
		if (is_admin()) {
			add_filter( 'creditcard_filter_tgmpa_required_plugins',			'creditcard_cf7_tgmpa_required_plugins' );
		}
	}
}

// Filter to add in the required plugins list
if ( !function_exists( 'creditcard_cf7_tgmpa_required_plugins' ) ) {
	
	function creditcard_cf7_tgmpa_required_plugins($list=array()) {
		if (in_array('contact-form-7', creditcard_storage_get('required_plugins'))) {
			// CF7 plugin
			$list[] = array(
					'name' 		=> esc_html__('Contact Form 7', 'creditcard'),
					'slug' 		=> 'contact-form-7',
					'required' 	=> false
			);
		}
		return $list;
	}
}



// Check if cf7 installed and activated
if ( !function_exists( 'creditcard_exists_cf7' ) ) {
	function creditcard_exists_cf7() {
		return class_exists('WPCF7');
	}
}
	
// Enqueue custom styles
if ( !function_exists( 'creditcard_cf7_frontend_scripts' ) ) {
	
	function creditcard_cf7_frontend_scripts() {
		if (creditcard_is_on(creditcard_get_theme_option('debug_mode')) && creditcard_get_file_dir('plugins/contact-form-7/contact-form-7.css')!='') {
			wp_enqueue_style( 'creditcard-contact-form-7',  creditcard_get_file_url('plugins/contact-form-7/contact-form-7.css'), array(), null );
		}
		if (creditcard_is_on(creditcard_get_theme_option('debug_mode')) && creditcard_get_file_dir('plugins/contact-form-7/contact-form-7.js')!='') {
			wp_enqueue_style( 'creditcard-contact-form-7',  creditcard_get_file_url('plugins/contact-form-7/contact-form-7.js'), array(), null );
		}
	}
}
	
// Merge custom styles
if ( !function_exists( 'creditcard_cf7_merge_styles' ) ) {
	
	function creditcard_cf7_merge_styles($list) {
		$list[] = 'plugins/contact-form-7/contact-form-7.css';
		return $list;
	}
}

// Merge custom scripts
if ( !function_exists( 'creditcard_cf7_merge_scripts' ) ) {
	
	function creditcard_cf7_merge_scripts($list) {
		$list[] = 'plugins/contact-form-7/contact-form-7.js';
		return $list;
	}
}
?>