<?php
/* The GDPR Framework support functions
------------------------------------------------------------------------------- */

// Theme init priorities:
// 9 - register other filters (for installer, etc.)
if ( ! function_exists( 'creditcard_gdpr_compliance_feed_theme_setup9' ) ) {
	add_action( 'after_setup_theme', 'creditcard_gdpr_compliance_theme_setup9', 9 );
	function creditcard_gdpr_compliance_theme_setup9() {
		if ( is_admin() ) {
			add_filter( 'creditcard_filter_tgmpa_required_plugins', 'creditcard_gdpr_compliance_tgmpa_required_plugins' );
		}
	}
}

// Filter to add in the required plugins list
if ( ! function_exists( 'creditcard_gdpr_compliance_tgmpa_required_plugins' ) ) {
	
	function creditcard_gdpr_compliance_tgmpa_required_plugins( $list = array() ) {
        if (in_array('gdpr-compliance', creditcard_storage_get('required_plugins')))
			$list[] = array(
				'name'     => esc_html__('Cookie Information', 'creditcard' ),
				'slug'     => 'wp-gdpr-compliance',
				'required' => false,
			);
		return $list;
	}
}

// Check if this plugin installed and activated
if ( ! function_exists( 'creditcard_exists_gdpr_compliance' ) ) {
	function creditcard_exists_gdpr_compliance() {
		return defined( 'WP_GDPR_C_ROOT_FILE' ) || defined( 'WPGDPRC_ROOT_FILE' );
	}
}
