<?php
/* Mail Chimp support functions
------------------------------------------------------------------------------- */

// Theme init priorities:
// 9 - register other filters (for installer, etc.)
if (!function_exists('creditcard_mailchimp_theme_setup9')) {
	add_action( 'after_setup_theme', 'creditcard_mailchimp_theme_setup9', 9 );
	function creditcard_mailchimp_theme_setup9() {
		if (creditcard_exists_mailchimp()) {
			add_action( 'wp_enqueue_scripts',							'creditcard_mailchimp_frontend_scripts', 1100 );
			add_filter( 'creditcard_filter_merge_styles',					'creditcard_mailchimp_merge_styles');
		}
		if (is_admin()) {
			add_filter( 'creditcard_filter_tgmpa_required_plugins',		'creditcard_mailchimp_tgmpa_required_plugins' );
		}
	}
}

// Check if plugin installed and activated
if ( !function_exists( 'creditcard_exists_mailchimp' ) ) {
	function creditcard_exists_mailchimp() {
		return function_exists('__mc4wp_load_plugin') || defined('MC4WP_VERSION');
	}
}

// Filter to add in the required plugins list
if ( !function_exists( 'creditcard_mailchimp_tgmpa_required_plugins' ) ) {
	
	function creditcard_mailchimp_tgmpa_required_plugins($list=array()) {
		if (in_array('mailchimp-for-wp', creditcard_storage_get('required_plugins')))
			$list[] = array(
				'name' 		=> esc_html__('MailChimp for WP', 'creditcard'),
				'slug' 		=> 'mailchimp-for-wp',
				'required' 	=> false
			);
		return $list;
	}
}



// Custom styles and scripts
//------------------------------------------------------------------------

// Enqueue custom styles
if ( !function_exists( 'creditcard_mailchimp_frontend_scripts' ) ) {
	
	function creditcard_mailchimp_frontend_scripts() {
		if (creditcard_exists_mailchimp()) {
			if (creditcard_is_on(creditcard_get_theme_option('debug_mode')) && creditcard_get_file_dir('plugins/mailchimp-for-wp/mailchimp-for-wp.css')!='')
				wp_enqueue_style( 'creditcard-mailchimp-for-wp',  creditcard_get_file_url('plugins/mailchimp-for-wp/mailchimp-for-wp.css'), array(), null );
		}
	}
}
	
// Merge custom styles
if ( !function_exists( 'creditcard_mailchimp_merge_styles' ) ) {
	
	function creditcard_mailchimp_merge_styles($list) {
		$list[] = 'plugins/mailchimp-for-wp/mailchimp-for-wp.css';
		return $list;
	}
}


// Add plugin-specific colors and fonts to the custom CSS
if (creditcard_exists_mailchimp()) { require_once CREDITCARD_THEME_DIR . 'plugins/mailchimp-for-wp/mailchimp-for-wp.styles.php'; }
?>