<?php
/* Revolution Slider support functions
------------------------------------------------------------------------------- */

// Theme init priorities:
// 9 - register other filters (for installer, etc.)
if (!function_exists('creditcard_revslider_theme_setup9')) {
	add_action( 'after_setup_theme', 'creditcard_revslider_theme_setup9', 9 );
	function creditcard_revslider_theme_setup9() {
		if (creditcard_exists_revslider()) {
			add_action( 'wp_enqueue_scripts', 					'creditcard_revslider_frontend_scripts', 1100 );
			add_filter( 'creditcard_filter_merge_styles',			'creditcard_revslider_merge_styles' );
		}
		if (is_admin()) {
			add_filter( 'creditcard_filter_tgmpa_required_plugins','creditcard_revslider_tgmpa_required_plugins' );
		}
	}
}

// Check if RevSlider installed and activated
if ( !function_exists( 'creditcard_exists_revslider' ) ) {
	function creditcard_exists_revslider() {
		return function_exists('rev_slider_shortcode');
	}
}

// Filter to add in the required plugins list
if ( !function_exists( 'creditcard_revslider_tgmpa_required_plugins' ) ) {
	
	function creditcard_revslider_tgmpa_required_plugins($list=array()) {
		if (in_array('revslider', creditcard_storage_get('required_plugins'))) {
			$path = creditcard_get_file_dir('plugins/revslider/revslider.zip');
			$list[] = array(
					'name' 		=> esc_html__('Revolution Slider', 'creditcard'),
					'slug' 		=> 'revslider',
					'version' 	=> '6.6.15',
					'source'	=> !empty($path) ? $path : 'upload://revslider.zip',
					'required' 	=> false
			);
		}
		return $list;
	}
}
	
// Enqueue custom styles
if ( !function_exists( 'creditcard_revslider_frontend_scripts' ) ) {
	
	function creditcard_revslider_frontend_scripts() {
		if (creditcard_is_on(creditcard_get_theme_option('debug_mode')) && creditcard_get_file_dir('plugins/revslider/revslider.css')!='')
			wp_enqueue_style( 'creditcard-revslider',  creditcard_get_file_url('plugins/revslider/revslider.css'), array(), null );
	}
}
	
// Merge custom styles
if ( !function_exists( 'creditcard_revslider_merge_styles' ) ) {
	
	function creditcard_revslider_merge_styles($list) {
		$list[] = 'plugins/revslider/revslider.css';
		return $list;
	}
}
?>