<?php
/* Essential Grid support functions
------------------------------------------------------------------------------- */


// Theme init priorities:
// 9 - register other filters (for installer, etc.)
if (!function_exists('creditcard_trx_updater_theme_setup9')) {
    add_action( 'after_setup_theme', 'creditcard_trx_updater_theme_setup9', 9 );
    function creditcard_trx_updater_theme_setup9() {
        if (is_admin()) {
            add_filter( 'creditcard_filter_tgmpa_required_plugins',		'creditcard_trx_updater_tgmpa_required_plugins' );
        }
    }
}

// Check if plugin installed and activated
if ( !function_exists( 'creditcard_exists_trx_updater' ) ) {
    function creditcard_exists_trx_updater() {
        return function_exists( 'trx_updater_load_plugin_textdomain' );
    }
}

// Filter to add in the required plugins list
if ( !function_exists( 'creditcard_trx_updater_tgmpa_required_plugins' ) ) {
    function creditcard_trx_updater_tgmpa_required_plugins($list=array()) {
        if (in_array('trx_updater', creditcard_storage_get('required_plugins'))) {
            $path = creditcard_get_file_dir('plugins/trx_updater/trx_updater.zip');
            $list[] = array(
                'name' 		=> esc_html__('ThemeREX Updater', 'creditcard'),
                'slug' 		=> 'trx_updater',
                'source'	=> !empty($path) ? $path : 'upload://trx_updater.zip',
                'required' 	=> false,
                'version'	=> '2.1.0',
            );
        }
        return $list;
    }
}

?>