<?php
/**
 * The Sidebar containing the main widget areas.
 *
 * @package WordPress
 * @subpackage CREDITCARD
 * @since CREDITCARD 1.0
 */

if (creditcard_sidebar_present()) {
	ob_start();
	$creditcard_sidebar_name = creditcard_get_theme_option('sidebar_widgets');
	creditcard_storage_set('current_sidebar', 'sidebar');
	if ( is_active_sidebar($creditcard_sidebar_name) ) {
		dynamic_sidebar($creditcard_sidebar_name);
	}
	$creditcard_out = trim(ob_get_contents());
	ob_end_clean();
	if (!empty($creditcard_out)) {
		$creditcard_sidebar_position = creditcard_get_theme_option('sidebar_position');
		?>
		<div class="sidebar <?php echo esc_attr($creditcard_sidebar_position); ?> widget_area<?php if (!creditcard_is_inherit(creditcard_get_theme_option('sidebar_scheme'))) echo ' scheme_'.esc_attr(creditcard_get_theme_option('sidebar_scheme')); ?>" role="complementary">
			<div class="sidebar_inner">
				<?php
				do_action( 'creditcard_action_before_sidebar' );
				creditcard_show_layout(preg_replace("/<\/aside>[\r\n\s]*<aside/", "</aside><aside", $creditcard_out));
				do_action( 'creditcard_action_after_sidebar' );
				?>
			</div><!-- /.sidebar_inner -->
		</div><!-- /.sidebar -->
		<?php
	}
}
?>