<?php
/**
 * The template to display default site footer
 *
 * @package WordPress
 * @subpackage CREDITCARD
 * @since CREDITCARD 1.0.10
 */

$creditcard_footer_scheme =  creditcard_is_inherit(creditcard_get_theme_option('footer_scheme')) ? creditcard_get_theme_option('color_scheme') : creditcard_get_theme_option('footer_scheme');
$creditcard_footer_id = str_replace('footer-custom-', '', creditcard_get_theme_option("footer_style"));
$creditcard_footer_meta = get_post_meta($creditcard_footer_id, 'trx_addons_options', true);
?>
<footer class="footer_wrap footer_custom footer_custom_<?php echo esc_attr($creditcard_footer_id); 
						?> footer_custom_<?php echo esc_attr(sanitize_title(get_the_title($creditcard_footer_id))); 
						if (!empty($creditcard_footer_meta['margin']) != '') 
							echo ' '.esc_attr(creditcard_add_inline_css_class('margin-top: '.esc_attr(creditcard_prepare_css_value($creditcard_footer_meta['margin'])).';'));
						?> scheme_<?php echo esc_attr($creditcard_footer_scheme); 
						?>">
	<?php
    // Custom footer's layout
    do_action('creditcard_action_show_layout', $creditcard_footer_id);
	?>
</footer><!-- /.footer_wrap -->
