<?php
/**
 * The template to display the site logo in the footer
 *
 * @package WordPress
 * @subpackage CREDITCARD
 * @since CREDITCARD 1.0.10
 */

// Logo
if (creditcard_is_on(creditcard_get_theme_option('logo_in_footer'))) {
	$creditcard_logo_image = '';
	if (creditcard_get_retina_multiplier(2) > 1)
		$creditcard_logo_image = creditcard_get_theme_option( 'logo_footer_retina' );
	if (empty($creditcard_logo_image)) 
		$creditcard_logo_image = creditcard_get_theme_option( 'logo_footer' );
	$creditcard_logo_text   = get_bloginfo( 'name' );
	if (!empty($creditcard_logo_image) || !empty($creditcard_logo_text)) {
		?>
		<div class="footer_logo_wrap">
			<div class="footer_logo_inner">
				<?php
				if (!empty($creditcard_logo_image)) {
					$creditcard_attr = creditcard_getimagesize($creditcard_logo_image);
					echo '<a href="'.esc_url(home_url('/')).'"><img src="'.esc_url($creditcard_logo_image).'" class="logo_footer_image" alt="'.esc_attr__('img', 'creditcard').'"'.(!empty($creditcard_attr[3]) ? sprintf(' %s', $creditcard_attr[3]) : '').'></a>' ;
				} else if (!empty($creditcard_logo_text)) {
					echo '<h1 class="logo_footer_text"><a href="'.esc_url(home_url('/')).'">' . esc_html($creditcard_logo_text) . '</a></h1>';
				}
				?>
			</div>
		</div>
		<?php
	}
}
?>