<?php
/**
 * The template to display the widgets area in the footer
 *
 * @package WordPress
 * @subpackage CREDITCARD
 * @since CREDITCARD 1.0.10
 */

// Footer sidebar
$creditcard_footer_name = creditcard_get_theme_option('footer_widgets');
$creditcard_footer_present = !creditcard_is_off($creditcard_footer_name) && is_active_sidebar($creditcard_footer_name);
if ($creditcard_footer_present) { 
	creditcard_storage_set('current_sidebar', 'footer');
	$creditcard_footer_wide = creditcard_get_theme_option('footer_wide');
	ob_start();
	if ( is_active_sidebar($creditcard_footer_name) ) {
		dynamic_sidebar($creditcard_footer_name);
	}
	$creditcard_out = trim(ob_get_contents());
	ob_end_clean();
	if (!empty($creditcard_out)) {
		$creditcard_out = preg_replace("/<\\/aside>[\r\n\s]*<aside/", "</aside><aside", $creditcard_out);
		$creditcard_need_columns = true;
		if ($creditcard_need_columns) {
			$creditcard_columns = max(0, (int) creditcard_get_theme_option('footer_columns'));
			if ($creditcard_columns == 0) $creditcard_columns = min(4, max(1, substr_count($creditcard_out, '<aside ')));
			if ($creditcard_columns > 1)
				$creditcard_out = preg_replace("/class=\"widget /", "class=\"column-1_".esc_attr($creditcard_columns).' widget ', $creditcard_out);
			else
				$creditcard_need_columns = false;
		}
		?>
		<div class="footer_widgets_wrap widget_area<?php echo !empty($creditcard_footer_wide) ? ' footer_fullwidth' : ''; ?> sc_layouts_row  sc_layouts_row_type_normal">
			<div class="footer_widgets_inner widget_area_inner">
				<?php 
				if (!$creditcard_footer_wide) { 
					?><div class="content_wrap"><?php
				}
				if ($creditcard_need_columns) {
					?><div class="columns_wrap"><?php
				}
				do_action( 'creditcard_action_before_sidebar' );
				creditcard_show_layout($creditcard_out);
				do_action( 'creditcard_action_after_sidebar' );
				if ($creditcard_need_columns) {
					?></div><!-- /.columns_wrap --><?php
				}
				if (!$creditcard_footer_wide) {
					?></div><!-- /.content_wrap --><?php
				}
				?>
			</div><!-- /.footer_widgets_inner -->
		</div><!-- /.footer_widgets_wrap -->
		<?php
	}
}
?>