<?php
/**
 * The template to display custom header from the ThemeREX Addons Layouts
 *
 * @package WordPress
 * @subpackage CREDITCARD
 * @since CREDITCARD 1.0.06
 */

$creditcard_header_css = $creditcard_header_image = '';
$creditcard_header_video = creditcard_get_header_video();
if (true || empty($creditcard_header_video)) {
	$creditcard_header_image = get_header_image();
	if (creditcard_is_on(creditcard_get_theme_option('header_image_override')) && apply_filters('creditcard_filter_allow_override_header_image', true)) {
		if (is_category()) {
			if (($creditcard_cat_img = creditcard_get_category_image()) != '')
				$creditcard_header_image = $creditcard_cat_img;
		} else if (is_singular() || creditcard_storage_isset('blog_archive')) {
			if (has_post_thumbnail()) {
				$creditcard_header_image = wp_get_attachment_image_src( get_post_thumbnail_id(), 'full' );
				if (is_array($creditcard_header_image)) $creditcard_header_image = $creditcard_header_image[0];
			} else
				$creditcard_header_image = '';
		}
	}
}

$creditcard_header_id = str_replace('header-custom-', '', creditcard_get_theme_option("header_style"));
$creditcard_header_meta = get_post_meta($creditcard_header_id, 'trx_addons_options', true);

?><header class="top_panel top_panel_custom top_panel_custom_<?php echo esc_attr($creditcard_header_id); 
						?> top_panel_custom_<?php echo esc_attr(sanitize_title(get_the_title($creditcard_header_id)));
						echo !empty($creditcard_header_image) || !empty($creditcard_header_video) 
							? ' with_bg_image' 
							: ' without_bg_image';
						if ($creditcard_header_video!='') 
							echo ' with_bg_video';
						if ($creditcard_header_image!='') 
							echo ' '.esc_attr(creditcard_add_inline_css_class('background-image: url('.esc_url($creditcard_header_image).');'));
						if (!empty($creditcard_header_meta['margin']) != '') 
							echo ' '.esc_attr(creditcard_add_inline_css_class('margin-bottom: '.esc_attr(creditcard_prepare_css_value($creditcard_header_meta['margin'])).';'));
						if (is_single() && has_post_thumbnail()) 
							echo ' with_featured_image';
						if (creditcard_is_on(creditcard_get_theme_option('header_fullheight'))) 
							echo ' header_fullheight trx-stretch-height';
						?> scheme_<?php echo esc_attr(creditcard_is_inherit(creditcard_get_theme_option('header_scheme')) 
														? creditcard_get_theme_option('color_scheme') 
														: creditcard_get_theme_option('header_scheme'));
						?>"><?php

	// Background video
	if (!empty($creditcard_header_video)) {
		get_template_part( 'templates/header-video' );
	}
		
	// Custom header's layout
	do_action('creditcard_action_show_layout', $creditcard_header_id);

	// Header widgets area
	get_template_part( 'templates/header-widgets' );
		
?></header>