<?php
/**
 * The template to display the page title and breadcrumbs
 *
 * @package WordPress
 * @subpackage CREDITCARD
 * @since CREDITCARD 1.0
 */

// Page (category, tag, archive, author) title

if ( creditcard_need_page_title() ) {
	creditcard_sc_layouts_showed('title', true);
	creditcard_sc_layouts_showed('postmeta', true);
	?>
	<div class="top_panel_title sc_layouts_row sc_layouts_row_type_normal">
		<div class="content_wrap">
			<div class="sc_layouts_column sc_layouts_column_align_center">
				<div class="sc_layouts_item">
					<div class="sc_layouts_title sc_align_center">
						<?php
						// Post meta on the single post
						if ( is_single() )  {
							?><div class="sc_layouts_title_meta"><?php
								creditcard_show_post_meta(apply_filters('creditcard_filter_post_meta_args', array(
									'components' => 'categories,date,counters,edit',
									'counters' => 'views,comments,likes',
									'seo' => true
									), 'header', 1)
								);
							?></div><?php
						}
						
						// Blog/Post title
						?><div class="sc_layouts_title_title"><?php
							$creditcard_blog_title = creditcard_get_blog_title();
							$creditcard_blog_title_text = $creditcard_blog_title_class = $creditcard_blog_title_link = $creditcard_blog_title_link_text = '';
							if (is_array($creditcard_blog_title)) {
								$creditcard_blog_title_text = $creditcard_blog_title['text'];
								$creditcard_blog_title_class = !empty($creditcard_blog_title['class']) ? ' '.$creditcard_blog_title['class'] : '';
								$creditcard_blog_title_link = !empty($creditcard_blog_title['link']) ? $creditcard_blog_title['link'] : '';
								$creditcard_blog_title_link_text = !empty($creditcard_blog_title['link_text']) ? $creditcard_blog_title['link_text'] : '';
							} else
								$creditcard_blog_title_text = $creditcard_blog_title;
							?>
							<h1 class="sc_layouts_title_caption<?php echo esc_attr($creditcard_blog_title_class); ?>"><?php
								$creditcard_top_icon = creditcard_get_category_icon();
								if (!empty($creditcard_top_icon)) {
									$creditcard_attr = creditcard_getimagesize($creditcard_top_icon);
									?><img src="<?php echo esc_url($creditcard_top_icon); ?>" alt="'.esc_attr__('img', 'creditcard').'" <?php if (!empty($creditcard_attr[3])) creditcard_show_layout($creditcard_attr[3]);?>><?php
								}
								echo wp_kses_post($creditcard_blog_title_text);
							?></h1>
							<?php
							if (!empty($creditcard_blog_title_link) && !empty($creditcard_blog_title_link_text)) {
								?><a href="<?php echo esc_url($creditcard_blog_title_link); ?>" class="theme_button theme_button_small sc_layouts_title_link"><?php echo esc_html($creditcard_blog_title_link_text); ?></a><?php
							}
							
							// Category/Tag description
							if ( is_category() || is_tag() || is_tax() ) 
								the_archive_description( '<div class="sc_layouts_title_description">', '</div>' );
		
						?></div><?php
	
						// Breadcrumbs
						?><div class="sc_layouts_title_breadcrumbs"><?php
							do_action( 'creditcard_action_breadcrumbs');
						?></div>
					</div>
				</div>
			</div>
		</div>
	</div>
	<?php
}
?>