<?php
/**
 * The template to display the background video in the header
 *
 * @package WordPress
 * @subpackage CREDITCARD
 * @since CREDITCARD 1.0.14
 */
$creditcard_header_video = creditcard_get_header_video();
$creditcard_embed_video = '';
if (!empty($creditcard_header_video) && !creditcard_is_from_uploads($creditcard_header_video)) {
	if (creditcard_is_youtube_url($creditcard_header_video) && preg_match('/[=\/]([^=\/]*)$/', $creditcard_header_video, $matches) && !empty($matches[1])) {
		?><div id="background_video" data-youtube-code="<?php echo esc_attr($matches[1]); ?>"></div><?php
	} else {
		global $wp_embed;
		if (false && is_object($wp_embed)) {
			$creditcard_embed_video = do_shortcode($wp_embed->run_shortcode( '[embed]' . trim($creditcard_header_video) . '[/embed]' ));
			$creditcard_embed_video = creditcard_make_video_autoplay($creditcard_embed_video);
		} else {
			$creditcard_header_video = str_replace('/watch?v=', '/embed/', $creditcard_header_video);
			$creditcard_header_video = creditcard_add_to_url($creditcard_header_video, array(
				'feature' => 'oembed',
				'controls' => 0,
				'autoplay' => 1,
				'showinfo' => 0,
				'modestbranding' => 1,
				'wmode' => 'transparent',
				'enablejsapi' => 1,
				'origin' => home_url(),
				'widgetid' => 1
			));
			$creditcard_embed_video = '<iframe src="' . esc_url($creditcard_header_video) . '" width="1170" height="658" allowfullscreen="0" frameborder="0"></iframe>';
		}
		?><div id="background_video"><?php creditcard_show_layout($creditcard_embed_video); ?></div><?php
	}
}
?>