<?php
/**
 * The template to display the widgets area in the header
 *
 * @package WordPress
 * @subpackage CREDITCARD
 * @since CREDITCARD 1.0
 */

// Header sidebar
$creditcard_header_name = creditcard_get_theme_option('header_widgets');
$creditcard_header_present = !creditcard_is_off($creditcard_header_name) && is_active_sidebar($creditcard_header_name);
if ($creditcard_header_present) { 
	creditcard_storage_set('current_sidebar', 'header');
	$creditcard_header_wide = creditcard_get_theme_option('header_wide');
	ob_start();
	if ( is_active_sidebar($creditcard_header_name) ) {
		dynamic_sidebar($creditcard_header_name);
	}
	$creditcard_widgets_output = ob_get_contents();
	ob_end_clean();
	if (!empty($creditcard_widgets_output)) {
		$creditcard_widgets_output = preg_replace("/<\/aside>[\r\n\s]*<aside/", "</aside><aside", $creditcard_widgets_output);
		$creditcard_need_columns = strpos($creditcard_widgets_output, 'columns_wrap')===false;
		if ($creditcard_need_columns) {
			$creditcard_columns = max(0, (int) creditcard_get_theme_option('header_columns'));
			if ($creditcard_columns == 0) $creditcard_columns = min(6, max(1, substr_count($creditcard_widgets_output, '<aside ')));
			if ($creditcard_columns > 1)
				$creditcard_widgets_output = preg_replace("/class=\"widget /", "class=\"column-1_".esc_attr($creditcard_columns).' widget ', $creditcard_widgets_output);
			else
				$creditcard_need_columns = false;
		}
		?>
		<div class="header_widgets_wrap widget_area<?php echo !empty($creditcard_header_wide) ? ' header_fullwidth' : ' header_boxed'; ?>">
			<div class="header_widgets_inner widget_area_inner">
				<?php 
				if (!$creditcard_header_wide) { 
					?><div class="content_wrap"><?php
				}
				if ($creditcard_need_columns) {
					?><div class="columns_wrap"><?php
				}
				do_action( 'creditcard_action_before_sidebar' );
				creditcard_show_layout($creditcard_widgets_output);
				do_action( 'creditcard_action_after_sidebar' );
				if ($creditcard_need_columns) {
					?></div>	<!-- /.columns_wrap --><?php
				}
				if (!$creditcard_header_wide) {
					?></div>	<!-- /.content_wrap --><?php
				}
				?>
			</div>	<!-- /.header_widgets_inner -->
		</div>	<!-- /.header_widgets_wrap -->
		<?php
	}
}
?>