<?php
/**
 * The template to display posts in widgets and/or in the search results
 *
 * @package WordPress
 * @subpackage CREDITCARD
 * @since CREDITCARD 1.0
 */

$creditcard_post_id    = get_the_ID();
$creditcard_post_date  = creditcard_get_date();
$creditcard_post_title = get_the_title();
$creditcard_post_link  = get_permalink();
$creditcard_post_author_id   = get_the_author_meta('ID');
$creditcard_post_author_name = get_the_author_meta('display_name');
$creditcard_post_author_url  = get_author_posts_url($creditcard_post_author_id, '');

$creditcard_args = get_query_var('creditcard_args_widgets_posts');
$creditcard_show_date = isset($creditcard_args['show_date']) ? (int) $creditcard_args['show_date'] : 1;
$creditcard_show_image = isset($creditcard_args['show_image']) ? (int) $creditcard_args['show_image'] : 1;
$creditcard_show_author = isset($creditcard_args['show_author']) ? (int) $creditcard_args['show_author'] : 1;
$creditcard_show_counters = isset($creditcard_args['show_counters']) ? (int) $creditcard_args['show_counters'] : 1;
$creditcard_show_categories = isset($creditcard_args['show_categories']) ? (int) $creditcard_args['show_categories'] : 1;

$creditcard_output = creditcard_storage_get('creditcard_output_widgets_posts');

$creditcard_post_counters_output = '';
if ( $creditcard_show_counters ) {
	$creditcard_post_counters_output = '<span class="post_info_item post_info_counters">'
								. creditcard_get_post_counters('comments')
							. '</span>';
}


$creditcard_output .= '<article class="post_item with_thumb">';

if ($creditcard_show_image) {
	$creditcard_post_thumb = get_the_post_thumbnail($creditcard_post_id, creditcard_get_thumb_size('extra'), array(
		'alt' => get_the_title()
	));
	if ($creditcard_post_thumb) $creditcard_output .= '<div class="post_thumb">' . ($creditcard_post_link ? '<a href="' . esc_url($creditcard_post_link) . '">' : '') . ($creditcard_post_thumb) . ($creditcard_post_link ? '</a>' : '') . '</div>';
}

$creditcard_output .= '<div class="post_content">'
			. ($creditcard_show_categories 
					? '<div class="post_categories">'
						. creditcard_get_post_categories()
						. $creditcard_post_counters_output
						. '</div>' 
					: '')
			. '<h6 class="post_title">' . ($creditcard_post_link ? '<a href="' . esc_url($creditcard_post_link) . '">' : '') . ($creditcard_post_title) . ($creditcard_post_link ? '</a>' : '') . '</h6>'
			. apply_filters('creditcard_filter_get_post_info', 
								'<div class="post_info">'
									. ($creditcard_show_date 
										? '<span class="post_info_item post_info_posted">'
											. ($creditcard_post_link ? '<a href="' . esc_url($creditcard_post_link) . '" class="post_info_date">' : '') 
											. esc_html($creditcard_post_date) 
											. ($creditcard_post_link ? '</a>' : '')
											. '</span>'
										: '')
									. ($creditcard_show_author 
										? '<span class="post_info_item post_info_posted_by">' 
											. esc_html__('by', 'creditcard') . ' ' 
											. ($creditcard_post_link ? '<a href="' . esc_url($creditcard_post_author_url) . '" class="post_info_author">' : '') 
											. esc_html($creditcard_post_author_name) 
											. ($creditcard_post_link ? '</a>' : '') 
											. '</span>'
										: '')
									. (!$creditcard_show_categories && $creditcard_post_counters_output
										? $creditcard_post_counters_output
										: '')
								. '</div>')
		. '</div>'
	. '</article>';
creditcard_storage_set('creditcard_output_widgets_posts', $creditcard_output);
?>